package voicerecordingvisualizerwrapper;

import main.java.com.tyorikan.voicerecordingvisualizer.VisualizerView;
import main.java.com.tyorikan.voicerecordingvisualizer.RecordingSampler;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
import android.view.Gravity; 

import android.util.Log;
import android.view.ViewTreeObserver;

import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import android.os.Build;
import android.os.Bundle;



@ActivityObject
//@Events(values={"value_changed(retval as Float)"})
@Author("Github: Takayuki Yorikane, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("VisualizerView")
//@DependsOn(values={"android-support-annotations"})
public class voiceRecordingVisualizerWrapper extends ViewWrapper<VisualizerView> implements DesignerCustomView, RecordingSampler.CalculateVolumeListener  {


	private BA ba;
	private String eventName;
        private VisualizerView cv;
        private RecordingSampler mRecordingSampler;



	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new VisualizerView(ba.context, null);
                this.setObject(cv);

                mRecordingSampler = new RecordingSampler();
                mRecordingSampler.setVolumeListener(this);
                mRecordingSampler.setSamplingInterval(100);
                mRecordingSampler.link(cv);
                addListener2();
 	}





          public void addListener2() {
            ViewTreeObserver observer = cv.getViewTreeObserver();
            observer.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
                @Override
                public void onGlobalLayout() {
                    cv.setBaseY(cv.getHeight());
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
                        cv.getViewTreeObserver().removeOnGlobalLayoutListener(this);
                    } else {
                        cv.getViewTreeObserver().removeGlobalOnLayoutListener(this);
                    }
                }
            });
          }





//    @Hide
//    public void addListener(){

//        cv.setCallback(new Wheel.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[]{retval});
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


//        });
//    }


//      @Hide
//      public void addListener2(){
//        cv.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//              if (ba.subExists(eventName + "_button_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
//              }
//            }
//        });
//      }

//    public void addImage(String draw) {
//		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
//               cv.setForeground(DrawableID);
//		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//                 cv.setForeground(drawable); 
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}



        public void toggleRecording() {
                if (mRecordingSampler.isRecording()) {
                    mRecordingSampler.stopRecording();
                } else {
                    mRecordingSampler.startRecording();
                }
        }



        public void releaseRecorder() {
            mRecordingSampler.release();
        }


    @Override
    public void onCalculateVolume(int volume) {
        // for custom implement
//        BA.Log("" + String.valueOf(volume));
    }

/**
 * Set the number of columns for the visualizer
 */
    public void setNumberOfColumns(int noc){
      cv.setNumberOfColumns(noc);
      cv.invalidate();
    }

/**
 * Set the render color of the visualizer
 */
    public void setRenderColor(int rc){
      cv.setRenderColor(rc);
      cv.invalidate();
    }

/**
 * Set the render type
 * 1 = Bar Graph
 * 2 = Pixel
 * It will default to Bar if an invalid value is passed
 */
    public void setRenderType(int rt){
      if (rt ==1) 
         cv.setRenderType(1);
      if (rt ==2) 
         cv.setRenderType(2);
      cv.invalidate();
    }

/**
 * Set the top render range of the visualizer
 */
//    public void setRenderRange(int rr){         
//      cv.setRenderRange(rr);
//      cv.invalidate();
//    }

//    public void setBaseY(int baseY) {
//        cv.setBaseY(baseY);
//        cv.invalidate();
//    }



   
}
